Bug 52086 - Nullable structs with implicit operators generate invalid IL code when compiling with Mono
Summary: Nullable structs with implicit operators generate invalid IL code when compil...
Status: RESOLVED FIXED
Alias: None
Product: Compilers
Classification: Mono
Component: C# (show other bugs)
Version: unspecified
Hardware: PC Linux
: --- normal
Target Milestone: ---
Assignee: Marek Safar
URL:
Depends on:
Blocks:
 
Reported: 2017-01-31 17:07 UTC by Hans Wolff
Modified: 2017-02-15 16:26 UTC (History)
2 users (show)

Tags:
Is this bug a regression?: ---
Last known good build:


Attachments
Small project to reproduce the crash (2.97 KB, application/zip)
2017-01-31 17:07 UTC, Hans Wolff
Details


Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on GitHub or Developer Community with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
RESOLVED FIXED

Description Hans Wolff 2017-01-31 17:07:20 UTC
Created attachment 19667 [details]
Small project to reproduce the crash

Comparing a nullable struct with overloaded implicit operators to a non-nullable representation crashes the application when compiled under Mono.

Steps to reproduce using already installed Mono:

> xbuild NullableStructBug.csproj
> mono bin/Debug/NullableStructBug.exe

Alternative steps to reproduce using Docker:

> docker build -t bug . && docker run -it --rm bug

Expected output (as seen when compiled using MS .NET Framework):

"All OK"

Actual output (when compiled using Mono):

"Unhandled Exception:
System.InvalidProgramException: Invalid IL code in NullableStructBug.Program:Main (): IL_0037: clt"
Comment 1 Marek Safar 2017-02-15 16:26:57 UTC
Fixed in master